Gecode::Int::Linear::NqBoolInt< VX > Class Template Reference
Other available functionality » Integer propagators

Propagator for integer disequal to Boolean sum (cardinality) More...

`#include <linear.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
Public Member Functions inherited from Gecode::BinaryPropagator< VX, PC_INT_VAL >
virtual void | reschedule (Space &home)
| Schedule function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< VX > &b, int c)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

bool | resubscribe (Space &home, VX &y)
| Update subscription.
| NqBoolInt (Home home, ViewArray< VX > &b, int c)
| Constructor for posting.
| NqBoolInt (Space &home, NqBoolInt< VX > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::BinaryPropagator< VX, PC_INT_VAL >
| BinaryPropagator (Space &home, BinaryPropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< VX > | x
| Views not yet subscribed to.
int | c
| Righthandside.
Protected Attributes inherited from Gecode::BinaryPropagator< VX, PC_INT_VAL >
VX | x0
| Two views.
VX | x1

## Detailed Description

template<class VX>
class Gecode::Int::Linear::NqBoolInt< VX >

Propagator for integer disequal to Boolean sum (cardinality)

Requires

#include <gecode/int/linear.hh>
linear.hh

Definition at line 883 of file linear.hh.

## Constructor & Destructor Documentation

## NqBoolInt() [1/2]

template<class VX>

Gecode::Int::Linear::NqBoolInt< VX >::NqBoolInt | ( | Home | home,
|  | ViewArray< VX > & | b,
|  | int | c )

inline protected

Constructor for posting.

Definition at line 358 of file bool-int.hpp.

## NqBoolInt() [2/2]

template<class VX>

Gecode::Int::Linear::NqBoolInt< VX >::NqBoolInt | ( | Space & | home,
|  | NqBoolInt< VX > & | p )

inline protected

Constructor for cloning p.

Definition at line 375 of file bool-int.hpp.

## Member Function Documentation

## resubscribe()

template<class VX>

bool Gecode::Int::Linear::NqBoolInt< VX >::resubscribe | ( | Space & | home,
|  | VX & | y )

inline protected

Update subscription.

Definition at line 433 of file bool-int.hpp.

## copy()

template<class VX>

Actor * Gecode::Int::Linear::NqBoolInt< VX >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 421 of file bool-int.hpp.

## cost()

template<class VX>

PropCost Gecode::Int::Linear::NqBoolInt< VX >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low linear).

Reimplemented from Gecode::BinaryPropagator< VX, PC_INT_VAL >.

Definition at line 427 of file bool-int.hpp.

## propagate()

template<class VX>

ExecStatus Gecode::Int::Linear::NqBoolInt< VX >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 458 of file bool-int.hpp.

## post()

template<class VX>

ExecStatus Gecode::Int::Linear::NqBoolInt< VX >::post | ( | Home | home,
|  | ViewArray< VX > & | b,
|  | int | c )

inline static

Post propagator for .

Definition at line 394 of file bool-int.hpp.

## dispose()

template<class VX>

size_t Gecode::Int::Linear::NqBoolInt< VX >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::BinaryPropagator< VX, PC_INT_VAL >.

Definition at line 368 of file bool-int.hpp.

## Member Data Documentation

## x

template<class VX>

ViewArray<VX> Gecode::Int::Linear::NqBoolInt< VX >::x

protected

Views not yet subscribed to.

Definition at line 888 of file linear.hh.

## c

template<class VX>

int Gecode::Int::Linear::NqBoolInt< VX >::c

protected

Righthandside.

Definition at line 890 of file linear.hh.

The documentation for this class was generated from the following files:

- gecode/int/linear.hh
- gecode/int/linear/bool-int.hpp